PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
PSSLChannel Class Reference

This class will start a secure SSL based channel. More...

`#include <pssl.h>`

Inheritance diagram for PSSLChannel:
[legend]
Collaboration diagram for PSSLChannel:
[legend]

## Public Types
typedef PSSLContext::VerifyMode | VerifyMode

## Public Member Functions
| PSSLChannel (PSSLContext *context=NULL, PBoolean autoDeleteContext=false)
| Create a new channel given the context. More...
| PSSLChannel (PSSLContext &context)
| ~PSSLChannel ()
| Close and clear the SSL channel. More...
virtual PBoolean | Read (void *buf, PINDEX len)
| Low level read from the channel. More...
virtual PBoolean | Write (const void *buf, PINDEX len)
| Low level write to the channel. More...
virtual PBoolean | Close ()
| Close the channel. More...
virtual PBoolean | Shutdown (ShutdownValue)
| Close one or both of the data streams associated with a channel. More...
virtual PString | GetErrorText (ErrorGroup group=NumErrorGroups) const
| Get error message description. More...
virtual PBoolean | ConvertOSError (P_INT_PTR error, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
PBoolean | Accept ()
| Accept a new inbound connection (server). More...
PBoolean | Accept (PChannel &channel)
| Accept a new inbound connection (server). More...
PBoolean | Accept (PChannel *channel, PBoolean autoDelete=true)
| Accept a new inbound connection (server). More...
PBoolean | Connect ()
| Connect to remote server. More...
PBoolean | Connect (PChannel &channel)
| Connect to remote server. More...
PBoolean | Connect (PChannel *channel, PBoolean autoDelete=true)
| Connect to remote server. More...
bool | AddClientCA (const PSSLCertificate &certificate)
| Set the CA certificate(s) to send to client from server. More...
bool | AddClientCA (const PList< PSSLCertificate > &certificates)
PBoolean | UseCertificate (const PSSLCertificate &certificate)
| Use the certificate specified. More...
PBoolean | UsePrivateKey (const PSSLPrivateKey &key)
| Use the private key file specified. More...
PString | GetCipherList () const
| Get the available ciphers. More...
void | SetVerifyMode (VerifyMode mode)
| Set certificate verification mode for connection. More...
bool | GetPeerCertificate (PSSLCertificate &certificate, PString *error=NULL)
| Get the peer certificate, if there is one. More...
PSSLContext * | GetContext () const
virtual PBoolean | RawSSLRead (void *buf, PINDEX &len)
Public Member Functions inherited from PIndirectChannel
| PIndirectChannel ()
| Create a new indirect channel without any channels to redirect to. More...
| ~PIndirectChannel ()
| Close the indirect channel, deleting read/write channels if desired. More...
Comparison | Compare (const PObject &obj) const
| Determine if the two objects refer to the same indirect channel. More...
virtual PString | GetName () const
| Get the name of the channel. More...
virtual PBoolean | IsOpen () const
| Determine if the channel is currently open and read and write operations can be executed on it. More...
virtual bool | SetLocalEcho (bool localEcho)
| Set local echo mode. More...
virtual PChannel * | GetBaseReadChannel () const
| This function returns the eventual base channel for reading of a series of indirect channels provided by descendents of `PIndirectChannel`. More...
virtual PChannel * | GetBaseWriteChannel () const
| This function returns the eventual base channel for writing of a series of indirect channels provided by descendents of `PIndirectChannel`. More...
PBoolean | Open (PChannel &channel)
| Set the channel for both read and write operations. More...
PBoolean | Open (PChannel *channel, PBoolean autoDelete=true)
| Set the channel for both read and write operations. More...
PBoolean | Open (PChannel *readChannel, PChannel *writeChannel, PBoolean autoDeleteRead=true, PBoolean autoDeleteWrite=true)
| Set the channel for both read and write operations. More...
PChannel * | GetReadChannel () const
| Get the channel used for read operations. More...
bool | SetReadChannel (PChannel *channel, bool autoDelete=true, bool closeExisting=false)
| Set the channel for read operations. More...
PChannel * | GetWriteChannel () const
| Get the channel used for write operations. More...
PBoolean | SetWriteChannel (PChannel *channel, bool autoDelete=true, bool closeExisting=false)
| Set the channel for read operations. More...
Public Member Functions inherited from PChannel
PBoolean | SetErrorValues (Errors errorCode, int osError, ErrorGroup group=LastGeneralError)
| Set error values to those specified. More...
virtual PINDEX | HashFunction () const
| Calculate a hash value for use in sets and dictionaries. More...
P_INT_PTR | GetHandle () const
| Get the integer operating system handle for the channel. More...
void | SetReadTimeout (const PTimeInterval &time)
| Set the timeout for read operations. More...
PTimeInterval | GetReadTimeout () const
| Get the timeout for read operations. More...
virtual PINDEX | GetLastReadCount () const
| Get the number of bytes read by the last Read() call. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
PBoolean | ReadBlock (void *buf, PINDEX len)
| Read len bytes into the buffer from the channel. More...
PString | ReadString (PINDEX len)
| Read `len` character into a string from the channel. More...
void | SetWriteTimeout (const PTimeInterval &time)
| Set the timeout for write operations to complete. More...
PTimeInterval | GetWriteTimeout () const
| Get the timeout for write operations to complete. More...
virtual PBoolean | Write (const void *buf, PINDEX len, const void *)
| Low level write to the channel with marker. More...
virtual PINDEX | GetLastWriteCount () const
| Get the number of bytes written by the last Write() call. More...
PBoolean | WriteChar (int c)
| Write a single character to the channel. More...
PBoolean | WriteString (const PString &str)
| Write a string to the channel. More...
| ~PChannel ()
| Close down the channel. More...
Errors | GetErrorCode (ErrorGroup group=NumErrorGroups) const
| Get normalised error code. More...
int | GetErrorNumber (ErrorGroup group=NumErrorGroups) const
| Get OS errro code. More...
virtual bool | ReadAsync (AsyncContext &context)
| Begin an asynchronous read from channel. More...
virtual void | OnReadComplete (AsyncContext &context)
| User callback function for when a `ReadAsync()` call has completed or timed out. More...
virtual bool | WriteAsync (AsyncContext &context)
| Begin an asynchronous write from channel. More...
virtual void | OnWriteComplete (AsyncContext &context)
| User callback function for when a WriteAsync() call has completed or timed out. More...
virtual bool | FlowControl (const void *flowData)
| Flow Control information Pass data to the channel for flowControl determination. More...
PBoolean | SetBufferSize (PINDEX newSize)
| Set the iostream buffer size for reads and writes. More...
PBoolean | SendCommandString (const PString &command)
| Send a command meta-string. More...
void | AbortCommandString ()
| Abort a command string that is in progress. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions
void | Construct (PSSLContext *ctx, PBoolean autoDel)
virtual PBoolean | OnOpen ()
| This callback is executed when the Open() function is called with open channels. More...

## Protected Attributes
PSSLContext * | m_context
bool | m_autoDeleteContext
ssl_st * | m_ssl
Protected Attributes inherited from PIndirectChannel
PChannel * | readChannel
| Channel for read operations. More...
PBoolean | readAutoDelete
| Automatically delete read channel on destruction. More...
PChannel * | writeChannel
| Channel for write operations. More...
PBoolean | writeAutoDelete
| Automatically delete write channel on destruction. More...
PReadWriteMutex | channelPointerMutex
| Race condition prevention on closing channel. More...
Protected Attributes inherited from PChannel
P_INT_PTR | os_handle
| The operating system file handle return by standard open() function. More...
Errors | lastErrorCode [NumErrorGroups+1]
| The platform independant error code. More...
int | lastErrorNumber [NumErrorGroups+1]
| The operating system error number (eg as returned by errno). More...
PINDEX | lastReadCount
| Number of byte last read by the Read() function. More...
PINDEX | lastWriteCount
| Number of byte last written by the Write() function. More...
PTimeInterval | readTimeout
| Timeout for read operations. More...
PTimeInterval | writeTimeout
| Timeout for write operations. More...
PString | channelName
| Name of channel. More...
PMutex | px_threadMutex
PXBlockType | px_lastBlockType
PThread * | px_readThread
PThread * | px_writeThread
PMutex | px_writeMutex
PThread * | px_selectThread [3]
PMutex | px_selectMutex [3]
Protected Attributes inherited from PObject
unsigned | m_traceContextIdentifier

## Additional Inherited Members
Static Public Member Functions inherited from PChannel
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
static PBoolean | ConvertOSError (P_INT_PTR libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Friends inherited from PObject

## Detailed Description

This class will start a secure SSL based channel.

## Member Typedef Documentation

typedef PSSLContext::VerifyMode PSSLChannel::VerifyMode

## Constructor & Destructor Documentation

PSSLChannel::PSSLChannel | ( | PSSLContext * | context = `NULL`,
|  | PBoolean | autoDeleteContext = `false`
| ) |  |

Create a new channel given the context.

If no context is given a default one is created.

Parameters

  context | Context for SSL channel
  autoDeleteContext | Flag for context to be automatically deleted.

PSSLChannel::PSSLChannel | ( | PSSLContext & | context | ) |

Parameters

  context | Context for SSL channel

PSSLChannel::~PSSLChannel | ( |  | ) |

Close and clear the SSL channel.

## Member Function Documentation

PBoolean PSSLChannel::Accept | ( |  | ) |

Accept a new inbound connection (server).

This version expects that the indirect channel has already been opened using Open() beforehand.

PBoolean PSSLChannel::Accept | ( | PChannel & | channel | ) |

Accept a new inbound connection (server).

Parameters

  channel | Channel to attach to.

PBoolean PSSLChannel::Accept | ( | PChannel * | channel,
|  | PBoolean | autoDelete = `true`
| ) |  |

Accept a new inbound connection (server).

Parameters

  channel | Channel to attach to.
  autoDelete | Flag for if channel should be automatically deleted.

bool PSSLChannel::AddClientCA | ( | const PSSLCertificate & | certificate | ) |

Set the CA certificate(s) to send to client from server.

bool PSSLChannel::AddClientCA | ( | const PList< PSSLCertificate > & | certificates | ) |

virtual PBoolean PSSLChannel::Close | ( |  | ) |
| virtual

Close the channel.

This will detach itself from the read and write channels and delete both of them if they are auto delete.

Returns
  true if the channel is closed.

Reimplemented from PIndirectChannel.

PBoolean PSSLChannel::Connect | ( |  | ) |

Connect to remote server.

This version expects that the indirect channel has already been opened using Open() beforehand.

PBoolean PSSLChannel::Connect | ( | PChannel & | channel | ) |

Connect to remote server.

Parameters

  channel | Channel to attach to.

PBoolean PSSLChannel::Connect | ( | PChannel * | channel,
|  | PBoolean | autoDelete = `true`
| ) |  |

Connect to remote server.

Parameters

  channel | Channel to attach to.
  autoDelete | Flag for if channel should be automatically deleted.

void PSSLChannel::Construct | ( | PSSLContext * | ctx,
|  | PBoolean | autoDel
| ) |  |
| protected

virtual PBoolean PSSLChannel::ConvertOSError | ( | P_INT_PTR | libcReturnValue,
|  | ErrorGroup | group = `LastGeneralError`
| ) |  |
| virtual

Convert an operating system error into platform independent error.

The internal error codes are set by this function. They may be obtained via the `GetErrorCode()` and `GetErrorNumber()` functions.

Returns
  true if there was no error.

Reimplemented from PChannel.

PString PSSLChannel::GetCipherList | ( |  | ) | const

Get the available ciphers.

PSSLContext* PSSLChannel::GetContext | ( |  | ) | const
| inline

References m_context.

virtual PString PSSLChannel::GetErrorText | ( | ErrorGroup | group = `NumErrorGroups` | ) | const
| virtual

Get error message description.

Return a string indicating the error message that may be displayed to the user. The error for the last I/O operation in this object is used.

Returns
  Operating System error description string.

Reimplemented from PIndirectChannel.

bool PSSLChannel::GetPeerCertificate | ( | PSSLCertificate & | certificate,
|  | PString * | error = `NULL`
| ) |  |

Get the peer certificate, if there is one.

If SetVerifyMode() has been called with VerifyPeer then this will return true if the remote does not offer a certiciate. If set to VerifyPeerMandatory, then it will return false. In both cases it will return false if the certificate is offered but cannot be authenticated.

virtual PBoolean PSSLChannel::OnOpen | ( |  | ) |
| protected virtual

This callback is executed when the Open() function is called with open channels.

It may be used by descendent channels to do any handshaking required by the protocol that channel embodies.

The default behaviour "connects" the channel to the OpenSSL library.

Returns
  Returns true if the protocol handshaking is successful.

Reimplemented from PIndirectChannel.

virtual PBoolean PSSLChannel::RawSSLRead | ( | void * | buf,
|  | PINDEX & | len
| ) |  |
| virtual

virtual PBoolean PSSLChannel::Read | ( | void * | buf,
|  | PINDEX | len
| ) |  |
| virtual

Low level read from the channel.

This function may block until the requested number of characters were read or the read timeout was reached. The GetLastReadCount() function returns the actual number of bytes read.

This will use the `readChannel` pointer to actually do the read. If `readChannel` is null the this asserts.

The GetErrorCode() function should be consulted after Read() returns false to determine what caused the failure.

Returns
  true indicates that at least one character was read from the channel. false means no bytes were read due to timeout or some other I/O error.

Reimplemented from PIndirectChannel.

void PSSLChannel::SetVerifyMode | ( | VerifyMode | mode | ) |

Set certificate verification mode for connection.

virtual PBoolean PSSLChannel::Shutdown | ( | ShutdownValue | option | ) |
| inline virtual

Close one or both of the data streams associated with a channel.

The behavour here is to pass the shutdown on to its read and write channels.

Returns
  true if the shutdown was successfully performed.

Reimplemented from PIndirectChannel.

PBoolean PSSLChannel::UseCertificate | ( | const PSSLCertificate & | certificate | ) |

Use the certificate specified.

PBoolean PSSLChannel::UsePrivateKey | ( | const PSSLPrivateKey & | key | ) |

Use the private key file specified.

virtual PBoolean PSSLChannel::Write | ( | const void * | buf,
|  | PINDEX | len
| ) |  |
| virtual

Low level write to the channel.

This function will block until the requested number of characters are written or the write timeout is reached. The GetLastWriteCount() function returns the actual number of bytes written.

This will use the `writeChannel` pointer to actually do the write. If `writeChannel` is null the this asserts.

The GetErrorCode() function should be consulted after Write() returns false to determine what caused the failure.

Returns
  true if at least len bytes were written to the channel.

Reimplemented from PIndirectChannel.

## Member Data Documentation

bool PSSLChannel::m_autoDeleteContext
| protected

PSSLContext* PSSLChannel::m_context
| protected

Referenced by GetContext().

ssl_st* PSSLChannel::m_ssl
| protected

The documentation for this class was generated from the following file:

- pssl.h